## ros-kinetic-simple-message 0.7.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(simple_message)

find_package(catkin REQUIRED COMPONENTS roscpp industrial_msgs)

# Build static libs, to reduce dependency-chaining for industrial_robot_client
set(ROS_BUILD_STATIC_LIBS true)
set(ROS_BUILD_SHARED_LIBS false)

# The simple_message library is designed to cross compile on Ubuntu
# and various robot controllers.  This requires conditionally compiling
# certain functions and headers.  The definition below enables compiling
# for a ROS node.
add_definitions(-DROS=1)           #build using ROS libraries
add_definitions(-DLINUXSOCKETS=1)  #use linux sockets for communication

set(SRC_FILES src/byte_array.cpp
	src/simple_message.cpp
	src/smpl_msg_connection.cpp

	src/socket/simple_socket.cpp
	src/socket/udp_socket.cpp
	src/socket/udp_client.cpp
	src/socket/udp_server.cpp
	src/socket/tcp_socket.cpp
	src/socket/tcp_client.cpp
	src/socket/tcp_server.cpp

	src/message_handler.cpp
	src/message_manager.cpp
	src/ping_handler.cpp
	src/ping_message.cpp
	src/joint_data.cpp
	src/joint_feedback.cpp
	src/joint_traj_pt.cpp
	src/joint_traj_pt_full.cpp
	src/joint_traj.cpp
	src/robot_status.cpp

	src/messages/joint_message.cpp
	src/messages/joint_feedback_message.cpp
	src/messages/joint_traj_pt_message.cpp
	src/messages/joint_traj_pt_full_message.cpp
	src/messages/robot_status_message.cpp

	src/simple_comms_fault_handler.cpp)
					
set(UTEST_SRC_FILES test/utest.cpp test/utest_message.cpp)

# The simple message make file builds two libraries: simple_message and
# simple_message_byte_swapping.
#
# simple_message - is the default library.  This library should be used
# when the target for the simple message is the same endian (i.e. both
# big-endian or little-endian).  Intel based machines are little endian
#
# simple_message_byte_swapping - is an alternative library that can be used
# when the target for simple message is a DIFFERENT endian AND when the target
# target cannot perform byte swapping (as is the case for some industrial
# controllers).  This library performs byte swapping at the lowest load/unload
# levels.

# NOTE: The libraries generated this package are not included in the catkin_package
# macro because libraries must be explicitly linked in projects that depend on this
# package.  If this is not done (and these libraries were exported), then multiple
# library definitions (normal - simple_message and byteswapped - simple_message_bswap)
# are both included (this is bad).

catkin_package(
    CATKIN_DEPENDS roscpp industrial_msgs
    INCLUDE_DIRS include
    LIBRARIES ${PROJECT_NAME}_dummy
    CFG_EXTRAS issue46_workaround.cmake
)


include_directories(include
  ${catkin_INCLUDE_DIRS}
)


# generate dummy library (we export it in catkin_package(..)), to force catkin
# to set up LIBRARY_DIRS properly.
# TODO: find out if LIBRARY_DIRS can be exported without dummy library target
add_custom_command(
  OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_dummy.cpp
  COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_dummy.cpp)
add_library(${PROJECT_NAME}_dummy ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_dummy.cpp)
# unfortunately this will have to be installed, but the linker will remove it
# from the library dependencies of dependent targets, as it contains no symbols
# that can be imported from it.
install(TARGETS ${PROJECT_NAME}_dummy DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})


# NOTE: All test files require TEST_PORT_BASE to be defined.  Defining different
# ports for each test executable allows them to run in parallel.

# DEFAULT LIBRARY (SAME ENDIAN)
add_library(simple_message ${SRC_FILES})
target_link_libraries(simple_message ${catkin_LIBRARIES})
add_dependencies(simple_message ${industrial_msgs_EXPORTED_TARGETS})

# ALTERNATIVE LIBRARY (DIFFERENT ENDIAN)
add_library(simple_message_bswap ${SRC_FILES})
set_target_properties(simple_message_bswap PROPERTIES COMPILE_DEFINITIONS "BYTE_SWAPPING")
target_link_libraries(simple_message_bswap ${catkin_LIBRARIES})
add_dependencies(simple_message_bswap ${industrial_msgs_EXPORTED_TARGETS})

# ALTERNATIVE LIBRARY (64-bit floats)
add_library(simple_message_float64 ${SRC_FILES})
set_target_properties(simple_message_float64 PROPERTIES COMPILE_DEFINITIONS "FLOAT64")
target_link_libraries(simple_message_float64 ${catkin_LIBRARIES})
add_dependencies(simple_message_float64 ${industrial_msgs_EXPORTED_TARGETS})

if(CATKIN_ENABLE_TESTING)

    catkin_add_gtest(utest ${UTEST_SRC_FILES})
    set_target_properties(utest PROPERTIES COMPILE_DEFINITIONS "TEST_PORT_BASE=11000")
    target_link_libraries(utest simple_message)

    catkin_add_gtest(utest_byte_swapping ${UTEST_SRC_FILES})
    set_target_properties(utest_byte_swapping PROPERTIES COMPILE_DEFINITIONS "TEST_PORT_BASE=12000")
    target_link_libraries(utest_byte_swapping simple_message_bswap)

    catkin_add_gtest(utest_float64 ${UTEST_SRC_FILES})
    set_target_properties(utest_float64 PROPERTIES COMPILE_DEFINITIONS "TEST_PORT_BASE=13000;FLOAT64")
    target_link_libraries(utest_float64 simple_message_float64)

    catkin_add_gtest(utest_udp ${UTEST_SRC_FILES})
    set_target_properties(utest_udp PROPERTIES COMPILE_DEFINITIONS "TEST_PORT_BASE=15000;UDP_TEST")
    target_link_libraries(utest_udp simple_message)

endif()

install(
    TARGETS simple_message simple_message_bswap simple_message_float64 
    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

install(
    DIRECTORY include/${PROJECT_NAME}/
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

=== debian/changelog ===
ros-kinetic-simple-message (0.7.1-1xenial) xenial; urgency=high

  * Fix incorrect return value if deserializing duration fails on ``joint_traj_pt`` (#226 <https://github.com/ros-industrial/industrial_core/issues/226>)
  * Updated all package xml files to version 2 (#232 <https://github.com/ros-industrial/industrial_core/issues/232>)
  * all: update maintainer email addresses (#222 <https://github.com/ros-industrial/industrial_core/issues/222>)
  * Contributors: Gonzalo Casas, Jeremy Zoss, Jorge Nicho, gavanderhoorn

 -- Shaun Edwards <shaun.edwards@gmail.com>  Wed, 18 Sep 2019 22:00:00 -0000

ros-kinetic-simple-message (0.7.0-1xenial) xenial; urgency=high

  * Updated the libraries install tags to follow the official documentation Fix #193 <https://github.com/ros-industrial/industrial_core/issues/193>
  * simple_message: get rid of obsolete gethostbyname. Fix #197 <https://github.com/ros-industrial/industrial_core/issues/197>
  * Added missed test dependencies to rosunit Fix #205 <https://github.com/ros-industrial/industrial_core/issues/205>
  * Fixed issue 157 regarding non-existing targets
  * simple_message: build unit tests conditionally #182 <https://github.com/ros-industrial/industrial_core/issues/182>
  * Contributors: Alexander Rössler, Dmitry Rozhkov, Levi Armstrong, Nadia Hammoudeh García, Shaun Edwards

 -- Shaun Edwards <sedwards@swri.org>  Mon, 11 Feb 2019 23:00:00 -0000

ros-kinetic-simple-message (0.6.0-1xenial) xenial; urgency=high

  * Added C++ 11 compile option
  * Contributors: Victor Lamoine

 -- Shaun Edwards <sedwards@swri.org>  Sun, 15 Jan 2017 23:00:00 -0000

ros-kinetic-simple-message (0.5.1-1xenial) xenial; urgency=high

  * Temporary fix, commented out disabled test to remove unstable build status
  * Changed test port numbers to unused range in linux.  utest_message now uses port range defined by macros (addresses failure to init server socket)
  * Amend to pull request #153 <https://github.com/ros-industrial/industrial_core/issues/153> (methods moved to TypedMessage)
  * robot_status: missing reply to SERVICE_REQUEST. Fix in robot_status_message and relay_handler.
  * simple_message: add doc to SpecialSeqValue enum members.
  * simple_message: fix SpecialSeqValue typo. Fix #130 <https://github.com/ros-industrial/industrial_core/issues/130>.
  * Contributors: Alberto Marini, Shaun Edwards, gavanderhoorn

 -- Shaun Edwards <sedwards@swri.org>  Sat, 14 Jan 2017 23:00:00 -0000

ros-kinetic-simple-message (0.5.0-1xenial) xenial; urgency=high

  * Switch ByteArray to <deque> for internal buffer
    - enables dynamic sizing, for larger messages
    * up to INT_MAX, which is unadvised
    - allows efficient data access at front/rear of msgs
    - maintains same external API
    * getRawDataPtr() is deprecated (not contiguous memory)
    - bugFix: SimpleSocket::receiveBytes() buffer-size check
    - update unit tests to handle ByteArray.MaxSize==INT_MAX
  * Contributors: Jeremy Zoss

 -- Shaun Edwards <sedwards@swri.org>  Sun, 21 Feb 2016 23:00:00 -0000

ros-kinetic-simple-message (0.4.3-1xenial) xenial; urgency=high

  * No changes

 -- Shaun Edwards <sedwards@swri.org>  Sat, 06 Feb 2016 23:00:00 -0000

ros-kinetic-simple-message (0.4.2-1xenial) xenial; urgency=high

  * No change

 -- Shaun Edwards <sedwards@swri.org>  Tue, 20 Oct 2015 22:00:00 -0000

ros-kinetic-simple-message (0.4.1-1xenial) xenial; urgency=high

  * Fixed changelog links to point to main repo
  * Contributors: Shaun Edwards

 -- Shaun Edwards <sedwards@swri.org>  Sun, 22 Mar 2015 23:00:00 -0000

ros-kinetic-simple-message (0.4.0-1xenial) xenial; urgency=high

  * Moved common socket contstructor code to simple_socket base class
  * Updated simple message header to reflect vendor ranges specified in REP-I0004
  * Correctly initialized connected state for udp connections
  * Fixed issue #48 <https://github.com/ros-industrial/industrial_core/issues/48>, logSocketError is now passed errno
  * Merge pull request #70 <https://github.com/ros-industrial/industrial_core/issues/70> from gt-ros-pkg/hydro-devel
    Fixing receiveBytes for UDP
  * Macro'ed out GETHOSTBYNAME, and fixed if-statement braces to be on a new line for consistency
  * Added support for gethostbyname, for passing host names in addition to IP addresses.
  * Making setConnected protected again, adding setDisconnected to public methods so that that method can be used to flag the connection as disconnected.
  * Putting back in timeout for receiveBytes
  * More formal fix for UDP communication.
    This should now make UDP sockets act almost exactly like the
    TCP sockets.
  * Fixing receiveBytes for UDP
  * robot_client: workaround for #46 <https://github.com/ros-industrial/industrial_core/issues/46>. Fix #67 <https://github.com/ros-industrial/industrial_core/issues/67>.
    This is an updated version of the workaround committed in 9df46977. Instead
    of requiring dependent packages to invoke the function defined in the
    CFG_EXTRAS cmake snippet, the snippet now sets up the linker path directly.
    Dependent packages now only need to remember to explicitly list their
    dependency on industrial_robot_client and simple_message in their
    add_library(..) statements.
  * Contributors: Fred Proctor, Kelsey, Shaun Edwards, gavanderhoorn

 -- Shaun Edwards <sedwards@swri.org>  Fri, 20 Mar 2015 23:00:00 -0000

ros-kinetic-simple-message (0.3.4-1xenial) xenial; urgency=high

  * robot_client: workaround for #46 <https://github.com/ros-industrial/industrial_core/issues/46>. Fix #67 <https://github.com/ros-industrial/industrial_core/issues/67>.
    This is an updated version of the workaround committed in 9df46977. Instead
    of requiring dependent packages to invoke the function defined in the
    CFG_EXTRAS cmake snippet, the snippet now sets up the linker path directly.
    Dependent packages now only need to remember to explicitly list their
    dependency on industrial_robot_client and simple_message in their


=== debian/control ===
Source: ros-kinetic-simple-message
Section: misc
Priority: extra
Maintainer: Shaun Edwards <shaun.edwards@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-catkin, ros-kinetic-industrial-msgs, ros-kinetic-roscpp, ros-kinetic-rosunit
Homepage: http://ros.org/wiki/simple_message
Standards-Version: 3.9.2

Package: ros-kinetic-simple-message
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-industrial-msgs, ros-kinetic-roscpp
Description: simple_message defines a simple messaging connection and protocol for communicating with an industrial robot controller.
 Additional handler and manager classes are included for handling connection limited systems. This package is part of the ROS-Industrial program.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-simple-message//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
